/* Tabela PROJETO: Projeto */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes feitas na tabela PROJETO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela de Projeto, utilizando a tabela
             Geral de Logs de Operaes. No momento, sero registradas apenas as alteraes nos campos
             'Quantidade Mnima de Horas' e 'Quantidade Mxima de Horas'*/
/* Data de criao: 25/11/2010 - Tarcsio Dias Pereira*/

CREATE OR REPLACE TRIGGER LOG_GEP_PROJETO
AFTER UPDATE OR INSERT OR DELETE
ON PROJETO FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(400);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_QTHRMAXPROJ  VARCHAR2(40);
  V_QTHRMINPROJ  VARCHAR2(40);
  V_FILIAL       VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_DSREMOTEADDR := '';
   V_DSREMOTEHOST := '';
   V_DSSERVERRDM  := '';
   V_DSSERVMETHOD := '';
   V_DSREMOTEOPER := '';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_IDTIPOOPER   := '';
   V_QTHRMAXPROJ  := '';
   V_QTHRMINPROJ  := '';
   V_FILIAL       := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN
      IF NOT((:NEW.QTHRMINPROJ) IS NULL) THEN
         V_QTHRMINPROJ := 'Quantidade mnima de horas: '||TRUNC(NVL(:NEW.QTHRMINPROJ,0))||':'||
                          LPAD(((NVL(:NEW.QTHRMINPROJ,0) - TRUNC(NVL(:NEW.QTHRMINPROJ,0)))*60),2,0);
      END IF;
      IF NOT((:NEW.QTHRMAXPROJ) IS NULL) THEN
         V_QTHRMAXPROJ := 'Quantidade mxima de horas: '||TRUNC(NVL(:NEW.QTHRMAXPROJ,0))||':'||
                          LPAD(((NVL(:NEW.QTHRMAXPROJ,0) - TRUNC(NVL(:NEW.QTHRMAXPROJ,0)))*60),2,0);
      END IF;

      IF NOT((V_QTHRMINPROJ) IS NULL) OR NOT((V_QTHRMAXPROJ) IS NULL) THEN
         V_DESC := V_QTHRMINPROJ||' '||V_QTHRMAXPROJ;
      END IF;

      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDPROJETO;
      V_IDTIPOOPER := '1';
      V_FILIAL := :NEW.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.QTHRMINPROJ,0) <> NVL(:NEW.QTHRMINPROJ,0)) THEN
            IF NOT((:OLD.QTHRMINPROJ) IS NULL) THEN
               V_DESC := V_DESC||'Qt. mnima de horas anterior: '||TRUNC(:OLD.QTHRMINPROJ)||':'||
                          LPAD(((:OLD.QTHRMINPROJ - TRUNC(:OLD.QTHRMINPROJ))*60),2,0)||' ';
            END IF;
               V_DESC := V_DESC||'Qt. mnima de horas atual: '||TRUNC(:NEW.QTHRMINPROJ)||':'||
                          LPAD(((:NEW.QTHRMINPROJ - TRUNC(:NEW.QTHRMINPROJ))*60),2,0)||' ';
         END IF;

         IF (NVL(:OLD.QTHRMAXPROJ,0) <> NVL(:NEW.QTHRMAXPROJ,0)) THEN
            IF NOT((:OLD.QTHRMAXPROJ) IS NULL) THEN
               V_DESC := V_DESC||'Qt. mxima de horas anterior: '||TRUNC(:OLD.QTHRMAXPROJ)||':'||
                          LPAD(((:OLD.QTHRMAXPROJ - TRUNC(:OLD.QTHRMAXPROJ))*60),2,0)||' ';
            END IF;
               V_DESC := V_DESC||'Qt. mxima de horas atual: '||TRUNC(:NEW.QTHRMAXPROJ)||':'||
                          LPAD(((:NEW.QTHRMAXPROJ - TRUNC(:NEW.QTHRMAXPROJ))*60),2,0)||' ';
         END IF;

         V_ITPESQ := :OLD.CDFILIAL||:OLD.CDPROJETO;
         V_IDTIPOOPER := '2';
         V_FILIAL := :OLD.CDFILIAL;
      ELSE
         IF DELETING THEN
            IF NOT((:OLD.QTHRMINPROJ) IS NULL) THEN
               V_QTHRMINPROJ := 'Quantidade mnima de horas: '||TRUNC(:OLD.QTHRMINPROJ)||':'||
                                LPAD(((:OLD.QTHRMINPROJ - TRUNC(:OLD.QTHRMINPROJ))*60),2,0);
            END IF;
            IF NOT((:OLD.QTHRMAXPROJ) IS NULL) THEN
               V_QTHRMAXPROJ := 'Quantidade mxima de horas: '||TRUNC(:OLD.QTHRMAXPROJ)||':'||
                                LPAD(((:OLD.QTHRMAXPROJ - TRUNC(:OLD.QTHRMAXPROJ))*60),2,0);
            END IF;

            IF NOT((V_QTHRMINPROJ) IS NULL) OR NOT((V_QTHRMAXPROJ) IS NULL) THEN
               V_DESC := V_QTHRMINPROJ||' '||V_QTHRMAXPROJ;
            END IF;

            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDPROJETO;
            V_IDTIPOOPER := '3';
            V_FILIAL := :OLD.CDFILIAL;
         END IF;
      END IF;
   END IF;
   
   IF NOT (V_DESC IS NULL) THEN

      V_DESC := SUBSTR(V_DESC, 1, 300);

      INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                             DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                             DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                  VALUES   ('PROJETO', SYSDATE , NVL(V_NMOPERADOR,' '),
                             V_IDTIPOOPER,   V_DESC, V_ITPESQ,
                             V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                             V_DSSERVMETHOD,   V_DSREMOTEOPER, V_FILIAL);
   END IF;
END;

/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GEP_PROJETO','5.11.000'); END;
/